use strict;
use warnings;

# based on http://www.din.or.jp/~ohzaki/perl.htm#File_Lock

sub lock {
	my %lfh = (dir => './lockdir/', basename => 'lockfile',
	           timeout => 60, trytime => 5, wait => 1, @_);
	return if $lfh{current};
	$lfh{path} = $lfh{dir} . $lfh{basename};
	
	for (my $i = 0; $i < $lfh{trytime}; $i++, sleep $lfh{wait}) {
		return \%lfh if (rename($lfh{path}, $lfh{current} = $lfh{path} . time));
	}
	my @filelist;
	{
		local *LOCKDIR;
		if (opendir(LOCKDIR, $lfh{dir})) {
			@filelist = readdir(LOCKDIR);
			closedir(LOCKDIR);
		}
	}
	foreach (@filelist) {
		if (/^$lfh{basename}(\d+)$/) {
			return \%lfh if (time - $1 > $lfh{timeout} and
				rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time));
			last;
		}
	}
	undef;
}

sub unlock {
	rename($_[0]->{current}, $_[0]->{path}) if $_[0]->{current};
	delete $_[0]->{current};
}

sub locked {
	my $lfh = shift;
	for (my $i = 0; $i < $lfh->{trytime}; $i++, sleep $lfh->{wait}) {
		return 0 if (-f $lfh->{path});
	}
	1;
}

1;
